# SelectStationWindow< T > Struct Template Reference

Window for selecting stations/waypoints to (distant) join to. More...

Inheritance diagram for SelectStationWindow< T >:

## Public Member Functions
| SelectStationWindow (const WindowDesc *desc, CommandContainer cmd, TileArea ta)
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | OnPaint ()
| The window must be repainted.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
virtual void | OnClick (Point pt, int widget)
| A click with the left mouse button has been made on the window.
virtual void | OnTick ()
| Called once per (game) tick.
virtual void | OnResize ()
| Called after the window got resized.
virtual void | OnInvalidateData (int data)
| Some data on this window has become invalid.
## Data Fields
CommandContainer | select_station_cmd
| Command to build new station.
TileArea | area
| Location of new station.

## Detailed Description

### template<class T>
struct SelectStationWindow< T >

Window for selecting stations/waypoints to (distant) join to.

Template Parameters:

  | T | The type of station to join with

Definition at line 1363 of file station_gui.cpp.

## Member Function Documentation

template<class T>

virtual void SelectStationWindow< T >::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize |
| ) |  |  | `[inline, virtual]`

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters:

  | widget | Widget number.
  | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  | fill | Fill step of the widget.
  | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 1378 of file station_gui.cpp.

References FACIL_WAYPOINT, GetStringBoundingBox(), Dimension::height, SmallVector< T, S >::Length(), maxdim(), SetDParam(), WD_FRAMERECT_BOTTOM, WD_FRAMERECT_LEFT, WD_FRAMERECT_RIGHT, WD_FRAMERECT_TOP, and Dimension::width.

template<class T>

virtual void SelectStationWindow< T >::OnPaint | ( |  | ) | `[inline, virtual]`

The window must be repainted.

Note:
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 1398 of file station_gui.cpp.

References Window::DrawWidgets().

template<class T>

virtual void SelectStationWindow< T >::DrawWidget | ( | const Rect & | r,
|  | int | widget |
| ) |  |  | const`[inline, virtual]`

Draw the contents of a nested widget.

Parameters:

  | r | Rectangle occupied by the widget.
  | widget | Number of the widget to draw.

Note:
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 1403 of file station_gui.cpp.

References DrawString(), FACIL_WAYPOINT, Scrollbar::GetCapacity(), Scrollbar::GetPosition(), Rect::left, SmallVector< T, S >::Length(), Window::resize, Rect::right, SetDParam(), ResizeInfo::step_height, Rect::top, Window::vscroll, WD_FRAMERECT_LEFT, WD_FRAMERECT_RIGHT, and WD_FRAMERECT_TOP.

template<class T>

virtual void SelectStationWindow< T >::OnClick | ( | Point | pt,
|  | int | widget |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.

Reimplemented from Window.

Definition at line 1424 of file station_gui.cpp.

References DeleteWindowById(), DoCommandP(), Scrollbar::GetPosition(), SmallVector< T, S >::Length(), CommandContainer::p2, Window::resize, SB(), SelectStationWindow< T >::select_station_cmd, ResizeInfo::step_height, Window::vscroll, WD_FRAMERECT_TOP, and Point::y.

template<class T>

virtual void SelectStationWindow< T >::OnResize | ( |  | ) | `[inline, virtual]`

Called after the window got resized.

For nested windows with a viewport, call NWidgetViewport::UpdateViewportCoordinates.

Reimplemented from Window.

Definition at line 1453 of file station_gui.cpp.

References Scrollbar::SetCapacityFromWidget(), Window::vscroll, WD_FRAMERECT_BOTTOM, and WD_FRAMERECT_TOP.

template<class T>

virtual void SelectStationWindow< T >::OnInvalidateData | ( | int | data | ) | `[inline, virtual]`

Some data on this window has become invalid.

Parameters:

  | data | information about the changed data.

Reimplemented from Window.

Definition at line 1458 of file station_gui.cpp.

References SelectStationWindow< T >::area, SmallVector< T, S >::Length(), Scrollbar::SetCount(), Window::SetDirty(), and Window::vscroll.

The documentation for this struct was generated from the following file:

- src/station_gui.cpp